#!usr/bin/perl

use Time::HiRes qw( gettimeofday tv_interval );
use strict;
use TokyoTyrant;
use String::Random;
use Data::Dumper;
use DateTime;

my $db = TokyoTyrant::RDBTBL->new;
if (!$db->open("localhost", 1991)) {
    print $db->ecode;
}

#$db->setindex('time', $db->ITDECIMAL);
#$db->setindex('uname', $db->ITLEXICAL);
#$db->setindex('ptoken', $db->ITTOKEN);

print "START\n";
for (my $i = 1; $i <= 1000000; $i++) {
    my @tokenlist = ();
    my $tokennum = int(rand()*8);
    my $key = String::Random->new->randregex('[A-Za-z0-9]{24}');
    for (my $j = 0; $j < $tokennum; $j++) {
	push(@tokenlist, String::Random->new->randregex('[A-Za-z0-9]{8}'));
    }
    my $cols = {
	'time'=>$i,
	'uname'=>String::Random->new->randregex('[A-F]{4}'),
	'ptoken'=>join(',', @tokenlist),
    };
    print Dumper($cols);    
    my $t0 = [gettimeofday];
    if (!$db->putkeep($key, $cols)) {
	printf "ERROR: %d\n", $db->ecode();
	last;
    }
    my $iv = tv_interval($t0);
    if ($iv > 10) {
	printf "TIME: %.2f %s\n", $iv, DateTime->now(time_zone=>'local');
    }
}

$db->close();
