#!usr/bin/perl

use Time::HiRes qw( gettimeofday tv_interval );
use strict;
use TokyoTyrant;
use DateTime;
use String::Random;
use Data::Dumper;
use Digest::SHA1 qw(sha1_hex);

my @users = ('FAAC','ADCD','BCCC','FAFF','CAAE','FFDF','AADF','AEEF','CCFB','AECD','FADA','EBEE','CBAB','BDAA','CAFA','EDFC','EFAD','DEDF','BEEF','BAFE','AEEF','FCCF','EFCD','DBEF','BCCD','BDCF','CDCD','DDBE','FBFD','CAAE','AFBD','BBFA','ADDC','FAAC','BCBF','BACB','CEAB','AEBE','CDFE','BDFB','FCEF','EDAA','EFEC','CEFF','DBCF','AAED','BECC','DCDB','CDFD','EACD');

my $t1 = [gettimeofday];
for (my $j = 0; $j < 100; $j++) {

    my $db = TokyoTyrant::RDBTBL->new;
    $db->open("localhost", 1991);

    my $qry = TokyoTyrant::RDBQRY->new($db);
    my $start = ($j * 12345) % 1000000;
    my $end = $start + 3600;
    my $user = $users[$j % 50];
    print "TIMERANGE: $start - $end  USER $user\n";
    $qry->addcond('uname', $qry->QCSTREQ, $user);
    $qry->addcond('time', $qry->QCNUMGE, $start);
    $qry->addcond('time', $qry->QCNUMLE, $end);
    $qry->setorder('time', $qry->QONUMASC);
    $qry->setlimit(100);
    my $t0 = [gettimeofday];
    my $rv = $qry->search();
    if (defined($rv)) {
	foreach my $key (@$rv) {
	    print "KEY: $key\n";
#   	    my $rcols = $db->get($key);
#	    print Dumper($rcols);
	}
#    print "SHA: " . sha1_hex(join(',', @$rv)) . "\n";
    } else {
	printf "NG\n";
    }
    printf "SEC: %f COUNT:%d J:%d\n", tv_interval($t0), $qry->searchcount(), $j;
    print $qry->hint;
    $db->close();
}
printf "TOTALSEC: %f\n", tv_interval($t1);